org 256

	mov dx,infm	;Print Info
	call pend	;New Line
	mov ah,4ah	;Set mem block size
	mov bx,3000h
	int 21h
	mov dx,nemm	;No Mem Error Message
	jc jcpe		;Exit if no mem

	mov si,81h	;Get arguments
	call sarg
	mov [dstr],dx	;Store DataString
	call sarg
	mov [astr],dx	;Store AddressString
	call sarg	
	mov ax,3d00h	;Open File
	stosb
	int 21h
	mov dx,ncom	;Can't open file
	jnc noen
jcpe	jmp pend	;Exit if can't open file

noen	mov bx,ax	;AX = File handle - BX = AX
	mov ax,cs	
	add ax,1000h
	mov ds,ax	;DS = Buffer
	mov ah,3fh	
	mov cx,8000h	;Read 8000h(32768) bytes
	xor dx,dx
	int 21h		;Read file
	mov dx,ax
	mov ah,3fh
	int 21h
	push cs
	pop ds
	push ax
	push dx
	add ax,dx
	mov cx,ax
	mov ah,3eh
	int 21h		;Close file
	push si
	mov dx,perm	;Display Permuting...
	mov ah,9
	int 21h
	xor di,di
plop	mov ax,cs
	add ax,1000h
	mov es,ax
	mov dl,[es:di]
	mov si,[dstr]
	call perc
	push bx
	mov dx,di
	mov si,[astr]
	call perc	
	mov ax,cs
	add ax,2000h
	mov es,ax
	pop ax
	mov [es:bx],al
	inc di
	loop plop

	pop si
	call sarg
	mov ax,3c00h	;Create or Truncate File
	mov [di],al
	xor cx,cx
	int 21h
	jnc opek

	mov dx,ncom
	call pend
	int 20h
opek	mov bx,ax
	xor dx,dx
	push es
	pop ds
	pop cx
	mov ah,40h
	int 21h
	mov dx,ax
	pop cx
	mov ah,40h
	int 21h
	mov ah,3eh
	int 21h
	push cs
	pop ds
	mov dx,donm

pend	mov ah,9	;Dos function - display string
	int 21h
	mov dx,endm
	int 21h
	ret

sarg	mov dx,si
	lodsb
	cmp al,' '+1
	jc sarg
carg	mov di,si
	lodsb
	cmp al,' '+1
	jnc carg
borr	ret	


; 0 = 48 - 9 = 57
; A = 65 - F = 70
; a = 97 - f = 102


perc	xor bx,bx	; Clear bx (result is stored here)
perr	lodsb		; Load byte at address DS:(E)SI into AL (dstr or astr)
	cmp al,' '+1	;  21h - 00100001 - 33  - !
	jc borr		; if end of string then return - BX = permuted value
	push cx		; Store CX
	mov cl,-'0'+1	;  D1h - 11010001 - 209 - ? (Negative 0)
	add cl,al	; Add char val onto negative 0 - Makes '0' = 00h etc.
	cmp cl,11	;  0Bh - 00001011 - 11  - ? - Is char above 9?
	jc noco		; If below 9 then jmp noco
	sub cl,'a'-'9'-1 ; 27h - 00100111 - 39  - ' - Makes 'a' = 10h etc.
noco	push dx		; 
	shr dx,cl	; Shift the value we want into CF
	pop dx		; 
	pop cx		;
	rcl bx,1	; Rotate CF into BX as bit 0
	jmp short perr	;
	
infm	db "Permutor v0.0 (C) Zilogator 2002 - "
	db "Usage: datastring addrstring infile outfile",0dh,0ah
	db "String is sequence of '0'..'9' or 'a'..'f', showing place of "
	db "input bits in",0dh,0ah
	db "output. So 24103 means i2->o4 i4->o3 i1->o2 i0->o1 i3->o0 etc. "
	db "Limit is 64kB.$"
nemm	db "Not enough memory!$"
ncom	db "Cannot open file!$"
perm	db "Permutating... $"
donm	db "Done.$"
endm	db 0dh,0ah,'$'

	apad
	absolute apad

dstr	resw 1
astr	resw 1